<!--
  Copyright: (c) 2020-2021, VTK Gent vzw
  GNU Affero General Public License v3.0+ (see COPYING or https://www.gnu.org/licenses/agpl-3.0.txt)
-->

<template>
  <v-card class="version pl-2 py-1" tile flat color="transparent">
    <!-- Date and show version button -->
    <v-row no-gutters justify="space-between">
      <!-- Information -->
      <v-col cols="auto">
        <!-- Date -->
        <div class="version-date">{{ versionDate }} (#{{ version.number }})</div>

        <!-- Author -->
        <div class="version-author">{{ $t('courses.description.version.card.by') }}{{ versionUser }}</div>

        <!-- Reverted from -->
        <div v-if="version.revertedVersion" class="version-reverted">
          {{ $t('courses.description.version.card.reverted') }}{{ version.revertedVersion.number }}
        </div>
      </v-col>

      <!-- Show version & Version Number -->
      <v-col cols="auto" class="d-flex flex-column justify-space-between align-end">
        <!-- Show version -->
        <v-btn
          color="primary"
          large
          :class="$vuetify.breakpoint.smAndUp ? 'studium-button' : ''"
          :text="$vuetify.breakpoint.smAndUp"
          :icon="$vuetify.breakpoint.xsOnly"
          :ripple="false"
          @click="versionDialog = true"
        >
          <template v-if="$vuetify.breakpoint.smAndUp">{{ $t('courses.description.version.card.show') }}</template>
          <template v-if="$vuetify.breakpoint.mdAndUp">
            {{ $t('courses.description.version.card.revision') }}
          </template>

          <v-icon color="primary" :right="$vuetify.breakpoint.smAndUp" medium> mdi-eye </v-icon>
        </v-btn>

        <!-- Revision Number -->
        <div v-if="$vuetify.breakpoint.smAndUp" class="version-number">#{{ version.number }}</div>
      </v-col>
    </v-row>

    <!-- Changes -->
    <v-row no-gutters>
      <!-- Changes -->
      <v-col cols="12" class="version-text pt-1 pb-1" @click="toggleOpen">
        <v-icon size="18" :class="open ? '' : 'version-closed'">mdi-chevron-down</v-icon>

        {{ $t('courses.description.version.card.changes') }}

        <span class="version-text--positive">+{{ version.changesAddedAmount }}</span>
        <span class="version-text--negative">-{{ version.changesDeletedAmount }}</span>
      </v-col>

      <!-- Changes Content -->
      <v-col cols="12">
        <course-description-version-diff v-if="open" :version="version" class="pt-1 px-5" />
      </v-col>
    </v-row>

    <!-- Dialog window for showing older versions -->
    <course-description-version-dialog
      v-if="versionDialog"
      :open.sync="versionDialog"
      :version="version"
      :course-code="courseCode"
      @success="onVersionSuccess"
    />
  </v-card>
</template>

<script lang="ts">
import { computed, defineComponent, Ref } from '@nuxtjs/composition-api'
import { useVModel } from '@vueuse/core'
import { format, parseISO } from 'date-fns'

import { useRouterHash } from '~/util/composables'

export default defineComponent({
  props: {
    // v-model value
    value: {
      type: Number,
      required: true,
    },

    // Version to display
    version: {
      type: Object,
      required: true,
    },

    // Course code of the course that contains the version
    courseCode: {
      type: String,
      required: true,
    },
  },
  setup(props, { emit, root }) {
    // v-model value
    const openIndex: Ref<any> = useVModel(props, 'value', emit, { eventName: 'input' })

    // If the version is open or not
    const open = computed(() => openIndex.value === props.version.number)

    // Open the version
    function toggleOpen() {
      openIndex.value = props.version.number

      // If the version is open, close it
      // Otherwise open it
      if (openIndex.value === props.version.number) {
        openIndex.value = -1
      } else {
        openIndex.value = props.version.number
      }
    }

    // Version date
    const versionDate = computed(() => {
      // Show different date format depending on width of device
      let dateOptions = ''
      if (root.$vuetify.breakpoint.xsOnly) {
        dateOptions = 'MMMM do, yyyy'
      } else {
        dateOptions = 'EEEE, MMMM do, yyyy'
      }
      return format(parseISO(props.version.revision.dateCreated), dateOptions)
    })

    // Version user
    const versionUser = computed(
      () => `${props.version.revision.user?.firstName} ${props.version.revision.user?.lastName}` || 'Unknown User'
    )

    // Should the history dialog be open
    const versionDialog = useRouterHash(`version-${props.version.number}`)

    // Handle version success
    function onVersionSuccess(message: String) {
      emit('success', message)
    }

    return {
      open,
      toggleOpen,
      versionDate,
      versionUser,
      versionDialog,
      onVersionSuccess,
    }
  },
})
</script>

<style lang="scss" scoped>
.version {
  margin-top: 12px;
  margin-bottom: 12px;
  border-left: 3px solid $primary !important;

  &-date {
    font-weight: 600;
    font-size: 17px;
    color: $primary !important;
  }

  &-author {
    color: $secondary;
  }

  &-reverted {
    color: $accent;
  }

  &-number {
    color: $secondary;
    margin-right: 16px;
  }

  &-text {
    cursor: pointer;

    &--positive {
      color: #217645;
    }

    &--negative {
      color: #dd2b0e;
    }

    &:hover {
      color: $primary;
    }
  }

  &-closed {
    transform: rotate(-90deg);
  }
}
</style>
